## mce 1.8.127.3+0m5+thumb0

=== Makefile ===
# Makefile for MCE
# Copyright © 2004-2001 Nokia Corporation.
# Written by David Weinehall

VERSION := 1.8.127

INSTALL := install -o root -g root --mode=755
INSTALL_DIR := install -d
INSTALL_DATA := install -o root -g root --mode=644

VARDIR := $(DESTDIR)/var/lib/mce
RUNDIR := $(DESTDIR)/var/run/mce
CONFDIR := /etc/mce
CONFINSTDIR := $(DESTDIR)$(CONFDIR)
SBINDIR := $(DESTDIR)/sbin
MODULEDIR := $(DESTDIR)/usr/lib/mce/modules
DBUSDIR := $(DESTDIR)/etc/dbus-1/system.d
LOCALEDIR := $(DESTDIR)/usr/share/locale
GCONFSCHEMADIR := $(DESTDIR)/etc/gconf/schemas

TOPDIR := $(shell /bin/pwd)
MODULE_DIR := $(TOPDIR)/modules

TARGETS := \
	mce
MODULES := \
	$(MODULE_DIR)/libfilter-brightness-als.so \
	$(MODULE_DIR)/libfilter-brightness-simple.so \
	$(MODULE_DIR)/libkeypad.so \
	$(MODULE_DIR)/libinactivity.so \
	$(MODULE_DIR)/libcamera.so \
	$(MODULE_DIR)/libalarm.so \
	$(MODULE_DIR)/libbattery.so \
	$(MODULE_DIR)/libdisplay.so \
	$(MODULE_DIR)/libled.so \
	$(MODULE_DIR)/libvibrator.so \
	$(MODULE_DIR)/libaccelerometer.so \
	$(MODULE_DIR)/libcallstate.so \
	$(MODULE_DIR)/libaudiorouting.so \
	$(MODULE_DIR)/libhomekey.so
MODEFILE := mode
CONFFILE := mce.ini
DBUSCONF := mce.conf
GCONFSCHEMAS := devicelock.schemas

WARNINGS := -Wextra -Wall -Wpointer-arith -Wundef -Wcast-align -Wshadow
WARNINGS += -Wbad-function-cast -Wwrite-strings -Wsign-compare
WARNINGS += -Waggregate-return -Wmissing-noreturn -Wnested-externs
WARNINGS += -Wchar-subscripts -Wmissing-prototypes -Wformat-security
WARNINGS += -Wformat=2 -Wformat-nonliteral -Winit-self
WARNINGS += -Wswitch-default -Wstrict-prototypes
WARNINGS += -Wdeclaration-after-statement
WARNINGS += -Wold-style-definition -Wmissing-declarations
WARNINGS += -Wmissing-include-dirs -Wstrict-aliasing=2
WARNINGS += -Wunsafe-loop-optimizations -Winvalid-pch
WARNINGS += -Waddress -Wvolatile-register-var -Wstrict-overflow=5
#WARNINGS += -Wmissing-format-attribute
#WARNINGS += -Wswitch-enum -Wunreachable-code
WARNINGS += -Wstack-protector
#WARNINGS += -Werror

COMMON_CFLAGS := $(WARNINGS)
COMMON_CFLAGS += -D_GNU_SOURCE
COMMON_CFLAGS += -DG_DISABLE_DEPRECATED
COMMON_CFLAGS += -DOSSOLOG_COMPILE
COMMON_CFLAGS += -DMCE_VAR_DIR=$(VARDIR) -DMCE_RUN_DIR=$(RUNDIR)
COMMON_CFLAGS += -DPRG_VERSION=$(VERSION)
#COMMON_CFLAGS += -funit-at-a-time -fwhole-program -combine
#COMMON_CFLAGS += -fstack-protector

MCE_CFLAGS := $(COMMON_CFLAGS)
MCE_CFLAGS += -DMCE_CONF_FILE=$(CONFDIR)/$(CONFFILE)
MCE_CFLAGS += $$(pkg-config glib-2.0 gio-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 osso-systemui-dbus conic --cflags)
MCE_LDFLAGS := -lcrypt -ldevlock $$(pkg-config glib-2.0 gio-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 dsme osso-systemui-dbus conic --libs)
LIBS := devlock.c tklock.c modetransition.c powerkey.c connectivity.c mce-dbus.c mce-dsme.c mce-gconf.c event-input.c event-switches.c mce-hal.c mce-log.c mce-conf.c datapipe.c mce-modules.c mce-io.c mce-lib.c
HEADERS := devlock.h tklock.h modetransition.h powerkey.h connectivity.h mce.h mce-dbus.h mce-dsme.h mce-gconf.h event-input.h event-switches.h mce-hal.h mce-log.h mce-conf.h datapipe.h mce-modules.h mce-io.h mce-lib.h

MODULE_CFLAGS := $(COMMON_CFLAGS)
MODULE_CFLAGS += -fPIC -shared
MODULE_CFLAGS += -I.
MODULE_CFLAGS += $$(pkg-config glib-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 --cflags)
MODULE_LDFLAGS := $$(pkg-config glib-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 libcal --libs)
MODULE_LIBS := datapipe.c mce-hal.c mce-log.c mce-dbus.c mce-conf.c mce-gconf.c median_filter.c mce-lib.c
MODULE_HEADERS := datapipe.h mce-hal.h mce-log.h mce-dbus.h mce-conf.h mce-gconf.h mce.h median_filter.h mce-lib.h

BLOCKER_CFLAGS := $(COMMON_CFLAGS)
BLOCKER_CFLAGS += $$(pkg-config glib-2.0 dbus-1 dbus-glib-1 --cflags)
BLOCKER_LDFLAGS := $$(pkg-config glib-2.0 dbus-1 dbus-glib-1 --libs)

.PHONY: all
all: $(TARGETS) $(MODULES) devlock-blocker

$(TARGETS): %: %.c $(HEADERS) $(LIBS)
	@$(CC) $(CFLAGS) $(MCE_CFLAGS) -o $@ $< $(LIBS) $(LDFLAGS) $(MCE_LDFLAGS)

$(MODULES): $(MODULE_DIR)/lib%.so: $(MODULE_DIR)/%.c $(MODULE_HEADERS) $(MODULE_LIBS)
	@$(CC) $(CFLAGS) $(MODULE_CFLAGS) -o $@ $< $(MODULE_LIBS) $(LDFLAGS) $(MODULE_LDFLAGS)

devlock-blocker: devlock-blocker.c mce-log.c mce-log.h
	@$(CC) $(CFLAGS) $(BLOCKER_CFLAGS) -o $@ $< $(LDFLAGS) mce-log.c $(BLOCKER_LDFLAGS)

.PHONY: tags
tags:
	@find . $(MODULE_DIR) -maxdepth 1 -type f -name '*.[ch]' | xargs ctags -a --extra=+f

.PHONY: install
install: all
	$(INSTALL_DIR) $(SBINDIR) $(DBUSDIR) $(VARDIR) $(MODULEDIR)	&&\
	$(INSTALL_DIR) $(RUNDIR) $(CONFINSTDIR)	$(GCONFSCHEMADIR)	&&\
	$(INSTALL) $(TARGETS) devlock-blocker $(SBINDIR)		&&\
	$(INSTALL) $(MODULES) $(MODULEDIR)				&&\
	$(INSTALL_DATA) $(MODEFILE) $(VARDIR)				&&\
	$(INSTALL_DATA) $(CONFFILE) $(CONFINSTDIR)			&&\
	$(INSTALL_DATA) $(GCONFSCHEMAS) $(GCONFSCHEMADIR)		&&\
	$(INSTALL_DATA) $(DBUSCONF) $(DBUSDIR)

.PHONY: fixme
fixme:
	@find . -type f -name "*.[ch]" | xargs grep -E "FIXME|XXX|TODO"

.PHONY: clean
clean:
	@rm -f $(TARGETS) $(MODULES) devlock-blocker

.PHONY: distclean
distclean: clean
	@rm -f tags

=== debian/changelog ===
mce (1.8.127.3+0m5+thumb0) unstable; urgency=low

  * Thumb2 compile

 -- Ivaylo Dimitrov <freemangordon@abv.bg>  Sat, 10 Oct 2015 11:47:23 +0300

mce (1.8.127.3+0m5) unstable; urgency=low

  * compile with correct splashscreen-dbus-names.h and modechange-dbus-names.h

 -- Ivaylo Dimitrov <freemangordon@abv.bg>  Thu, 10 Oct 2014 12:55:39 +0300

mce (1.8.127.2+0m5) unstable; urgency=low

  * fix condition in call_state_trigger
  * remove an extra space in log message
  * fix devlock_notify_remove parameters
  * tklock: fix keypress_trigger logic

 -- Ivaylo Dimitrov <freemangordon@abv.bg>  Thu, 09 Oct 2014 21:50:21 +0300

mce (1.8.127.1) unstable; urgency=low

  * Fix function get_product_id() - fix parsing /proc/cpuinfo
  * Add PatternBoost to mce.ini (used by BME Replacement and USB Mode)
  * Fix mce package dependences

 -- Pali Rohár <pali.rohar@gmail.com>  Sun, 18 May 2014 20:03:19 +0200

mce (1.8.127+0m5) unstable; urgency=low

  * 3.x kernel compatibility fixes
  * fix for problem reported at http://talk.maemo.org/showpost.php?p=1387420&postcount=34

 -- Ivaylo Dimitrov <freemangordon@abv.bg>  Mon, 24 Jan 2014 18:04:33 +0200

mce (1.8.126+0m5) unstable; urgency=low

  * Initial release of Fremantle MCE reverse engineering work
  * Some code taken from various tree versions under https://gitorious.org/meego-middleware/mce/

 -- Jonathan Wilson <jfwfreo@tpgi.com.au>  Thu, 26 Sep 2013 10:52:00 +0800

=== debian/control ===
Source: mce
Section: misc
Priority: optional
Maintainer: David Weinehall <david.weinehall@nokia.com>
Uploaders: Philippe De Swert <philippe.de-swert@nokia.com>, Pekka Lundström <pekka.lundstrom@nokia.com>
Build-Depends: debhelper (>= 4.1.0), mce-dev (>= 1.8.19), pkg-config, libglib2.0-dev (>= 2.18.0), libdbus-1-dev (>= 1.0.2), libdbus-glib-1-dev, libdsme0.2.0-dev (>=0.58), libgconf2-dev, osso-systemui-dbus-dev (>= 0.1.3), osso-systemui-powerkeymenu-dev, osso-systemui-tklock-dev, osso-systemui-devlock-dev, osso-systemui-splashscreen-dev, osso-systemui-modechange-dev, libconic0-dev (>= 0.15-0.1), dpkg-dev (>= 1.13.19), hald-addon-bme-dev, upstart-dev (>= 0.3.8-67), libcal-dev (>= 0.2.4), libdevlock-dev
Standards-Version: 3.7.3

Package: mce
Architecture: any
Depends: dbus, ${shlibs:Depends}, ${misc:Depends}, kernel-feature-errata-430973-workaround [armel]
Recommends: dsme (>= 0.30.11)
Conflicts: osso-systemui-tklock (<< 0.1.8.12), osso-applet-display (<< 1.4.2), libcodelockui1 (<< 1:1.5.5), hildon-desktop (<< 1:2.2.48-1), osso-systemui-alarm (<< 0.2.1.24), osso-systemui-devlock (<< 0.2.0.3)
Description: the Mode Control Entity for Nokia Internet Tablets
 This package contains the Mode Control Entity which provides
 mode management features.  This is a daemon that is the backend
 for many features on Nokia's Internet Tablets.

Package: mce-dbg
Section: devel
Priority: extra
Architecture: any
Depends: mce (= ${binary:Version})
Description: the Mode Control Entity for Nokia Internet Tablets
 This package contains the Mode Control Entity with debug symbols
 which provides mode management features.  This is a daemon that
 is the backend for many features on Nokia's Internet Tablets.

## mce 1.8.127.5+0m5

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 MCE_CFLAGS := $(COMMON_CFLAGS)
 MCE_CFLAGS += -DMCE_CONF_FILE=$(CONFDIR)/$(CONFFILE)
 MCE_CFLAGS += $$(pkg-config glib-2.0 gio-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 osso-systemui-dbus conic --cflags)
-MCE_LDFLAGS := -lcrypt -ldevlock $$(pkg-config glib-2.0 gio-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 dsme osso-systemui-dbus conic --libs)
+MCE_LDFLAGS := -lcrypt $$(pkg-config glib-2.0 gio-2.0 gmodule-2.0 dbus-1 dbus-glib-1 gconf-2.0 dsme osso-systemui-dbus conic libdevlock1 --libs)
 LIBS := devlock.c tklock.c modetransition.c powerkey.c connectivity.c mce-dbus.c mce-dsme.c mce-gconf.c event-input.c event-switches.c mce-hal.c mce-log.c mce-conf.c datapipe.c mce-modules.c mce-io.c mce-lib.c
 HEADERS := devlock.h tklock.h modetransition.h powerkey.h connectivity.h mce.h mce-dbus.h mce-dsme.h mce-gconf.h event-input.h event-switches.h mce-hal.h mce-log.h mce-conf.h datapipe.h mce-modules.h mce-io.h mce-lib.h

=== debian/changelog ===
mce (1.8.127.5+0m5) unstable; urgency=low

  * do not segfault in mce_get_io_monitor_name when input devices get changed.

 -- Ivaylo Dimitrov <freemangordon@abv.bg>  Sat, 29 Oct 2016 19:39:13 +0200

mce (1.8.127.4+0m5) unstable; urgency=low

  * Add support of various gpio switches through evdev interface and gpio-keys driver.
  * Implement smart match of input devices providing switch caps
  * *upport disabling the keys and switches provided by gpio-keys driver

 -- Ivaylo Dimitrov <freemangordon@abv.bg>  Mon, 4 Jan 2016 15:33:34 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 Package: mce
 Architecture: any
-Depends: dbus, ${shlibs:Depends}, ${misc:Depends}, kernel-feature-errata-430973-workaround [armel]
+Depends: dbus, ${shlibs:Depends}, ${misc:Depends}
 Recommends: dsme (>= 0.30.11)
 Conflicts: osso-systemui-tklock (<< 0.1.8.12), osso-applet-display (<< 1.4.2), libcodelockui1 (<< 1:1.5.5), hildon-desktop (<< 1:2.2.48-1), osso-systemui-alarm (<< 0.2.1.24), osso-systemui-devlock (<< 0.2.0.3)
 Description: the Mode Control Entity for Nokia Internet Tablets

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for mce using debhelper.
# Copyright © 2004-2009 Nokia Corporation.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

pkgdir = $(CURDIR)/debian/tmp

makefileversion := $$(grep -m1 '^VERSION' Makefile | sed -e 's/VERSION *:= *//')
changelogversion := $$(grep -m1 'mce (' debian/changelog | sed -e 's/mce (\(.*\)).*/\1/;s/\(^'$(makefileversion)'\).*/\1/')

CC = gcc
CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# Use soft-float and thumb mode if enabled
ifneq (,$(findstring thumb,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -mthumb
endif

.PHONY: clean
clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	$(MAKE) distclean

	dh_clean

.PHONY: check
check:
	@if [ x"$(makefileversion)" != x"$(changelogversion)" ]; then \
		printf "error: version-number mismatch\n"; \
		printf "Makefile version: $(makefileversion)\n"; \
		printf "changelog version: $(changelogversion)\n"; \
		exit 1; \
	fi

build-stamp:
	dh_testdir

	$(MAKE) CC="$(CC)" CFLAGS="$(CFLAGS)"

	touch build-stamp

.PHONY: build
build: check build-stamp

.PHONY: install
install:
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) install DESTDIR="$(pkgdir)"

.PHONY: binary-indep
binary-indep:
#nothing to see here, move along

.PHONY: binary-arch
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_install -s
	dh_installinit --name=mce -- defaults 21 79
	dh_installinit -r --no-start --name=zzinitdone -- start 99 2 3 4 5 . stop 00 0 1 2 3 4 5 6 .
	dh_installupstart
	dh_installxsession -u 'pre 04' --name=devlock-blocker
	dh_gconf
	dh_strip --dbg-package=mce
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

.PHONY: binary
binary: binary-indep binary-arch
